<template>
    <div class="login-view">
      <div class="header-form">
        <div class="header-form-title">Sablier</div>
        {{ formState }}
        <div v-if="errors.length">
          <b>Please correct the following error(s):</b>
          <ul>
            <li v-for="error in errors" :key="error">{{ error }}</li>
          </ul>
        </div>
      </div>
      <div class="login-form">
        <form id="logForm" v-on:submit.prevent="login">
          <h2>Login</h2>
          <label for="username">Username or email</label>
          <input type="text" v-model="username" name="username" />
          <label for="userpwd">Password</label>
          <input type="password" v-model="password" name="userpwd" />
          <input type="submit" class="login-button" value="Log In" />
          <div class="checkbox-group">
            <input type="checkbox" id="keepMeLoggedInOption" name="keepMeLoggedInOption" checked />
            <label for="keepMeLoggedInOption">Keep me logged in</label>
          </div>
          <a href="/" class>Forgot my password ?</a>
        </form>
      </div>
    </div>
</template>

<script>
export default {
  name: "Login",
  data: function() {
    return {
      username: null,
      password: null,
      formState: null,
      errors: []
    };
  },
  mounted: function() {
    if (this.$auth.isLoggedIn(this.$cookie)) {
      this.$auth.logOut(this.$cookie);
      this.$router.go();
    }
  },
  methods: {
    login: function() {
      this.$caller.login(this.username, this.password)
      .then(response => {
          if (response.data.error) {
            this.formState = response.data.error; 
            return; 
          }
          
          this.$router.push('/dashboard')
      })
      
      // , (err, data) => {
      //   if (err) this.formState = err;
      //   else this.formState = data.data;
      // });
    }
  }
};
</script>

<style>
.header-form {
  max-width: 400px;
  margin: auto;
  margin-top: 200px;
}

.header-form-title {
  font-size: 55px;
  font-weight: bold;
}

.login-form {
  text-align: left;
  border: 1px solid lightgray;
  border-radius: 10px;
  padding: 20px;
  flex-grow: 1;
  max-width: 400px;
  margin: auto;
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
  margin-top: 50px;
}

form {
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
}

.login-form > form > * {
  margin-bottom: 10px;
  width: 400px;
}

.login-form > form > input:not([type="checkbox"]) {
  /* Remove default style */
  -webkit-appearance: none;
  -moz-appearance: none;
  -ms-appearance: none;
  -o-appearance: none;
  appearance: none;
  border: 0px;
  border-bottom: 1px solid lightgray;
  font-size: 20px;
  line-height: 20px;
}

.login-button {
  height: 35px;
  border-radius: 10px;
  margin-top: 10px;
}
</style>